"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Make deep-readonly object
 *
 * From: https://stackoverflow.com/questions/41299642/how-to-use-javascript-proxy-for-nested-objects
 */
function asReadonly(obj) {
    const validator = {
        get: (target, key) => {
            const o = target[key];
            if (typeof o === "object" && o !== null) {
                return new Proxy(target[key], validator);
            }
            else {
                return target[key];
            }
        },
        set: (o, prop, name) => {
            throw new Error("ReadOnly Value in " + prop.toString());
        }
    };
    return new Proxy(obj, validator);
}
exports.asReadonly = asReadonly;
//# sourceMappingURL=deepreadonly.js.map